# Enunciado:
# Faça uma função que, dado um tipo (fire, water, grass, etc) de Pokémon,
# imprime todos os Pokémon com número menor ou igual a $151$. Dica: Use a
# PokéAPI: https://pokeapi.co

import requests


def get_json(url):
    """Retorna um dicionário com o JSON retornado da URL."""
    response = requests.get(url)
    return response.json()


def pega_tipo(tipo):
    """Retorna a URL do tipo passado como parâmetro."""
    json = get_json("https://pokeapi.co/api/v2/type")
    for d in json["results"]:
        if d["name"] == tipo:
            return d["url"]


def pega_pokemon(url_to_tipo):
    """Retorna uma lista com as URLs dos pokemon do tipo passado."""
    json = get_json(url_to_tipo)
    return [d["pokemon"]["url"] for d in json["pokemon"]]


def classico(url):
    """Retorna True se o pokemon for da primeira geração."""
    json = get_json(url)
    return json["id"] <= 151


def nome(url):
    """Retorna o nome do pokemon."""
    json = get_json(url)
    return json["name"]


tipo = input("Entre com o tipo: ")
url = pega_tipo(tipo)
pokemon = pega_pokemon(url)
classicos = [nome(p) for p in pokemon if classico(p)]
print(classicos)
